3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 USAGE="[--quiet] [--cached] \
8 [add <repo> [-b branch] <path>]|[status|init|update [-i|--init] [-N|--no-fetch]|summary [-n|--summary-limit <n>] [<commit>]] \
9 [--] [<path>...]|[foreach <command>]|[sync [--] [<path>...]]"
22 # print stuff on stdout unless -q was specified
32 # Resolve relative url by appending to parent's url
33 resolve_relative_url ()
35 remote=$(get_default_remote)
36 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
39 remoteurl=${remoteurl%/}
45 remoteurl="${remoteurl%/*}"
54 echo "$remoteurl/${url%/}"
58 # Get submodule info for registered submodules
59 # $@ = path to limit submodule list
63 git ls-files --error-unmatch --stage -- "$@" | grep '^160000 '
67 # Map submodule path to submodule name
73 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
74 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
75 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
76 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
78 die "No submodule mapping found in .gitmodules for path '$path'"
85 # Prior to calling, cmd_update checks that a possibly existing
86 # path is not a git repository.
87 # Likewise, cmd_add checks that path does not exist at all,
88 # since it is the location of a new submodule.
95 # If there already is a directory at the submodule path,
96 # expect it to be empty (since that is the default checkout
97 # action) and try to remove it.
98 # Note: if $path is a symlink to a directory the test will
99 # succeed but the rmdir will fail. We might want to fix this.
102 rmdir "$path" 2>/dev/null ||
103 die "Directory '$path' exist, but is neither empty nor a git repository"
107 die "A file already exist at path '$path'"
109 git-clone -n "$url" "$path" ||
110 die "Clone of '$url' into submodule path '$path' failed"
114 # Add a new submodule to the working tree, .gitmodules and the index
118 # optional branch is stored in global branch variable
122 # parse $args after "submodule ... add".
127 case "$2" in '') usage ;; esac
151 if test -z "$repo" -o -z "$path"; then
155 # assure repo is absolute or relative to parent
158 # dereference source url relative to parent's url
159 realrepo=$(resolve_relative_url "$repo") || exit
166 die "repo URL: '$repo' must be absolute or begin with ./|../"
170 # strip trailing slashes from path
171 path=$(echo "$path" | sed -e 's|/*$||')
173 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
174 die "'$path' already exists in the index"
176 # perhaps the path exists and is already a git repo, else clone it
179 if test -d "$path"/.git -o -f "$path"/.git
181 echo "Adding existing repo at '$path' to the index"
183 die "'$path' already exists and is not a valid git repo"
188 url=$(resolve_relative_url "$repo") || exit
194 git config submodule."$path".url "$url"
197 module_clone "$path" "$realrepo" || exit
198 (unset GIT_DIR; cd "$path" && git checkout -f -q ${branch:+-b "$branch" "origin/$branch"}) ||
199 die "Unable to checkout submodule '$path'"
203 die "Failed to add submodule '$path'"
205 git config -f .gitmodules submodule."$path".path "$path" &&
206 git config -f .gitmodules submodule."$path".url "$repo" &&
207 git add .gitmodules ||
208 die "Failed to register submodule '$path'"
212 # Execute an arbitrary command sequence in each checked out
215 # $@ = command to execute
220 while read mode sha1 stage path
222 if test -e "$path"/.git
224 say "Entering '$path'"
225 (cd "$path" && eval "$@") ||
226 die "Stopping at '$path'; script returned non-zero status."
232 # Register submodules in .git/config
234 # $@ = requested paths (default to all)
238 # parse $args after "submodule ... init".
260 while read mode sha1 stage path
262 # Skip already registered paths
263 name=$(module_name "$path") || exit
264 url=$(git config submodule."$name".url)
265 test -z "$url" || continue
267 url=$(git config -f .gitmodules submodule."$name".url)
269 die "No url found for submodule path '$path' in .gitmodules"
271 # Possibly a url relative to parent
274 url=$(resolve_relative_url "$url") || exit
278 git config submodule."$name".url "$url" ||
279 die "Failed to register url for submodule path '$path'"
281 say "Submodule '$name' ($url) registered for path '$path'"
286 # Update each submodule path to correct revision, using clone and checkout as needed
288 # $@ = requested paths (default to all)
292 # parse $args after "submodule ... update".
302 cmd_init "$@" || return
322 while read mode sha1 stage path
324 name=$(module_name "$path") || exit
325 url=$(git config submodule."$name".url)
328 # Only mention uninitialized submodules when its
329 # path have been specified
331 say "Submodule path '$path' not initialized" &&
332 say "Maybe you want to use 'update --init'?"
336 if ! test -d "$path"/.git -o -f "$path"/.git
338 module_clone "$path" "$url" || exit
341 subsha1=$(unset GIT_DIR; cd "$path" &&
342 git rev-parse --verify HEAD) ||
343 die "Unable to find current revision in submodule path '$path'"
346 if test "$subsha1" != "$sha1"
349 if test -z "$subsha1"
354 if test -z "$nofetch"
356 (unset GIT_DIR; cd "$path" &&
358 die "Unable to fetch in submodule path '$path'"
361 (unset GIT_DIR; cd "$path" &&
362 git-checkout $force -q "$sha1") ||
363 die "Unable to checkout '$sha1' in submodule path '$path'"
365 say "Submodule path '$path': checked out '$sha1'"
374 git describe "$2" 2>/dev/null ||
375 git describe --tags "$2" 2>/dev/null ||
376 git describe --contains "$2" 2>/dev/null ||
377 git describe --all --always "$2"
380 test -z "$revname" || revname=" ($revname)"
383 # Show commit summary for submodules in index or working tree
385 # If '--cached' is given, show summary between index and given commit,
386 # or between working tree and given commit
388 # $@ = [commit (default 'HEAD'),] requested paths (default all)
394 # parse $args after "submodule ... summary".
405 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
427 test $summary_limit = 0 && return
429 if rev=$(git rev-parse -q --verify "$1^0")
438 # Get modified modules cared by user
439 modules=$(git diff-index $cached --raw $head -- "$@" |
440 egrep '^:([0-7]* )?160000' |
441 while read mod_src mod_dst sha1_src sha1_dst status name
443 # Always show modules deleted or type-changed (blob<->module)
444 test $status = D -o $status = T && echo "$name" && continue
445 # Also show added or modified modules which are checked out
446 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
451 test -z "$modules" && return
453 git diff-index $cached --raw $head -- $modules |
454 egrep '^:([0-7]* )?160000' |
456 while read mod_src mod_dst sha1_src sha1_dst status name
458 if test -z "$cached" &&
459 test $sha1_dst = 0000000000000000000000000000000000000000
463 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
465 100644 | 100755 | 120000)
466 sha1_dst=$(git hash-object $name)
472 echo >&2 "unexpected mode $mod_dst"
479 test $mod_src = 160000 &&
480 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
483 test $mod_dst = 160000 &&
484 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
488 case "$missing_src,$missing_dst" in
490 errmsg=" Warn: $name doesn't contain commit $sha1_src"
493 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
496 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
501 if test $mod_src = 160000 -a $mod_dst = 160000
503 range="$sha1_src...$sha1_dst"
504 elif test $mod_src = 160000
510 GIT_DIR="$name/.git" \
511 git log --pretty=oneline --first-parent $range | wc -l
513 total_commits=" ($(($total_commits + 0)))"
517 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
518 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
521 if test $mod_dst = 160000
523 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
525 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
528 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
532 # Don't give error msg for modification whose dst is not submodule
533 # i.e. deleted or changed to blob
534 test $mod_dst = 160000 && echo "$errmsg"
536 if test $mod_src = 160000 -a $mod_dst = 160000
539 test $summary_limit -gt 0 && limit="-$summary_limit"
540 GIT_DIR="$name/.git" \
541 git log $limit --pretty='format: %m %s' \
542 --first-parent $sha1_src...$sha1_dst
543 elif test $mod_dst = 160000
545 GIT_DIR="$name/.git" \
546 git log --pretty='format: > %s' -1 $sha1_dst
548 GIT_DIR="$name/.git" \
549 git log --pretty='format: < %s' -1 $sha1_src
555 if test -n "$for_status"; then
556 echo "# Modified submodules:"
558 sed -e 's|^|# |' -e 's|^# $|#|'
564 # List all submodules, prefixed with:
565 # - submodule not initialized
566 # + different revision checked out
568 # If --cached was specified the revision in the index will be printed
569 # instead of the currently checked out revision.
571 # $@ = requested paths (default to all)
575 # parse $args after "submodule ... status".
600 while read mode sha1 stage path
602 name=$(module_name "$path") || exit
603 url=$(git config submodule."$name".url)
604 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
609 set_name_rev "$path" "$sha1"
610 if git diff-files --quiet -- "$path"
612 say " $sha1 $path$revname"
616 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
617 set_name_rev "$path" "$sha1"
619 say "+$sha1 $path$revname"
624 # Sync remote urls for submodules
625 # This makes the value for remote.$remote.url match the value
626 # specified in .gitmodules.
651 while read mode sha1 stage path
653 name=$(module_name "$path")
654 url=$(git config -f .gitmodules --get submodule."$name".url)
656 # Possibly a url relative to parent
659 url=$(resolve_relative_url "$url") || exit
663 if test -e "$path"/.git
668 remote=$(get_default_remote)
669 say "Synchronizing submodule url for '$name'"
670 git config remote."$remote".url "$url"
676 # This loop parses the command line arguments to find the
677 # subcommand name to dispatch. Parsing of the subcommand specific
678 # options are primarily done by the subcommand implementations.
679 # Subcommand specific options such as --branch and --cached are
680 # parsed here as well, for backward compatibility.
682 while test $# != 0 && test -z "$command"
685 add | foreach | init | update | status | summary | sync)
715 # No command word defaults to "status"
716 test -n "$command" || command=status
718 # "-b branch" is accepted only by "add"
719 if test -n "$branch" && test "$command" != add
724 # "--cached" is accepted only by "status" and "summary"
725 if test -n "$cached" && test "$command" != status -a "$command" != summary